package org.gunnm.lostrunner.maps;

import org.gunnm.lostrunner.model.Cube;
import org.gunnm.lostrunner.model.Warp;

public class Map5 implements MapInterface {

	private int NB_CUBES = 8;
	
	private int MAP_WIDTH = 6;
	private int MAP_DEPTH = 10;
	private int cubesPositions[][];
	private int heroPositionX;
	private int heroPositionZ;
	private int exitPositionX;
	private int exitPositionZ;
	
	public Map5()
	{
		cubesPositions = new int[NB_CUBES][2];
		int cubid;
		cubid = 0;
		for ( int i = 0 ; i < 4 ; i++)
		{
			cubesPositions[cubid][0] = MAP_WIDTH - i - 1;
			cubesPositions[cubid][1] = -MAP_DEPTH + i;
			cubid++;
		}	
		for ( int i = 0 ; i < 4  ; i++)
		{
			cubesPositions[cubid][0] =  i ;
			cubesPositions[cubid][1] = -MAP_DEPTH + 5 + i;
			cubid++;
		}		
		
		this.heroPositionX = 2;
		this.heroPositionZ = -1;
		

		this.exitPositionX = 4;
		this.exitPositionZ = -MAP_DEPTH;
	}	

	public int getHeroPositionX ()
	{
		return this.heroPositionX;
	}
	
	public int getHeroPositionZ ()
	{
		return this.heroPositionZ;
	}
	
	public int getExitPositionX ()
	{
		return this.exitPositionX;
	}
	
	public int getExitPositionZ ()
	{
		return this.exitPositionZ;
	}
	
	public int getNbCubes ()
	{
		return NB_CUBES;
	}
	
	public int getMapWidth ()
	{
		return MAP_WIDTH;
	}
	
	public int getMapDepth ()
	{
		return MAP_DEPTH;
	}
	
	public int getCubePositionX (int cubeId)
	{
		return cubesPositions[cubeId][0];
	}
	
	public int getCubePositionZ (int cubeId)
	{
		return cubesPositions[cubeId][1];
	}
	
	public boolean getCubeBouncing(int cubeId)
	{
		return true;
	}
	
	public int getCubeDirection(int cubeId)
	{
		if (cubeId == 6)
		{
			return Cube.DIRECTION_WEST_TO_EAST;
		}
		else
		{
			return Cube.DIRECTION_NORTH_TO_SOUTH;
		}
			
	}
	
	public int getCubeType (int cubeId)
	{
		if (cubeId == 6)
		{
			return Cube.TYPE_HORIZONTAL;
		}
		else
		{
			return Cube.TYPE_VERTICAL;
		}
	}

	public int getNbWarps()
	{
		return 0;
	}
	public int getWarpPositionX(int warpId)
	{
		return 0;
	}
	public int getWarpPositionY(int warpId)	
	{
		return 0;
	}
	
	public int getWarpPositionZ(int warpId)
	{
		return 0;
	}
	public int getWarpDirection (int warpId)
	{
		return Warp.WARP_TYPE_HORIZONTAL;
	}
	public float getCubeSpeed (int cubeId)
	{
		return Cube.DEFAULT_SPEED;
	}
	
	public float getCubeRotationSpeed (int cubeId)
	{
		return Cube.DEFAULT_ROTATION_SPEED;
	}
	public int getWarpConnection(int warpId)
	{
		return 0;
	}
}
